/*
Copyright (c) 2005 Thorsten Thielen <thth@c2226.de>

This work is licensed under the Creative Commons
Attribution-NonCommercial License. To view a copy of this license,
visit http://creativecommons.org/licenses/by-nc/2.5/ or send a letter
to Creative Commons, 543 Howard Street, 5th Floor, San Francisco,
California, 94105, USA.
*/

#declare M_ChessPawn = object {
    difference {
        object {
            Round_Cone_Union( <0.0,0.0,0.0>, 0.008, <0.0,0.025,0.0>, 0.0032, 0.0006)
            texture { T_White }
        }
        torus {
            0.0074, 0.0013
            translate <0.0,0.006,0.0>
            texture { T_Black }
        }
    }
}

#declare M_ChessKing = object {
    union {
        difference {
            Round_Cone_Union( <0.0,0.0,0.0>, 0.010, <0.0,0.031,0.0>, 0.005, 0.0006)
            torus {
                0.0093, 0.0013
                translate <0.0,0.006,0.0>
                texture { T_Black }
            }
        }
        union {
            object {
                Round_Box_Union( <-0.0028,-0.001,-0.001>, < 0.0028, 0.001, 0.001>, 0.0002 )
                translate <0.0,0.0335,0.0>
            }
            object {
                Round_Box_Union( <-0.0028,-0.001,-0.001>, < 0.0028, 0.001, 0.001>, 0.0002 )
                rotate z * 90
                translate <0.0,0.0335,0.0>
            }
            texture { T_Black }
        }
    }
    texture { T_White }
}

#declare M_ChessQueen = object {
    union {
        difference {
            Round_Cone_Union( <0.0,0.0,0.0>, 0.010, <0.0,0.031,0.0>, 0.005, 0.0006)
            torus {
                0.0093, 0.0013
                translate <0.0,0.006,0.0>
                texture { T_Black }
            }
        }
        object {
            Round_Box_Union( <-0.0029,-0.0029,-0.001>, < 0.0029, 0.0029, 0.001>, 0.0003 )
            // Round_Box_Union( <-0.0048,-0.0028,-0.0007>, < 0.0048, 0.0048, 0.0007>, 0.0002 )
            rotate <0,0,45>
            translate <0.0,0.033,0.0>
            texture { T_Black }
        }
/*        sphere {
            <0.0,0.033,0.0>, 0.0028
            texture { T_Black }
        } */
    }
    texture { T_White }
}

#declare M_ChessTower = object {
    union {
        difference {
            Round_Cone_Union( <0.0,0.0,0.0>, 0.009, <0.0,0.026,0.0>, 0.0045, 0.0006)
            torus {
                0.0085, 0.0013
                translate <0.0,0.006,0.0>
                texture { T_Black }
            }
        }
        object {
            Round_Box_Union( <-0.0029,-0.0029,-0.001>, < 0.0029, 0.0029, 0.001>, 0.0003 )
            // Round_Box_Union( <-0.0048,-0.0028,-0.0007>, < 0.0048, 0.0048, 0.0007>, 0.0002 )
            rotate <90,0,0>
            translate <0.0,0.0268,0.0>
            texture { T_Black }
        }
    }
    texture { T_White }
}

#declare M_ChessBishop = object {
    union {
        difference {
            Round_Cone_Union( <0.0,0.0,0.0>, 0.009, <0.0,0.026,0.0>, 0.0045, 0.0006)
            torus {
                0.0085, 0.0013
                translate <0.0,0.006,0.0>
                texture { T_Black }
            }
        }
        object {
            Round_Box_Union( <-0.0029,-0.0029,-0.001>, < 0.0029, 0.0029, 0.001>, 0.0003 )
            // Round_Box_Union( <-0.0048,-0.0028,-0.0007>, < 0.0048, 0.0048, 0.0007>, 0.0002 )
            rotate <-40,0,0>
            translate <0.0,0.022,-0.004>
            texture { T_Black }
        }
    }
    texture { T_White }
}

#declare M_ChessKnight = object {
    union {
        difference {
            Round_Cone_Union( <0.0,0.0,0.0>, 0.009, <0.0,0.026,0.0>, 0.0045, 0.0006)
            torus {
                0.0085, 0.0013
                translate <0.0,0.006,0.0>
                texture { T_Black }
            }
        }
        object {
            Round_Box_Union( <-0.0029,-0.0029,-0.001>, < 0.0029, 0.0029, 0.001>, 0.0003 )
            rotate <0,90,0>
            rotate <40,0,0>
            translate <0.0,0.026,-0.0035>
            texture { T_Black }
        }
    }
    texture { T_White }
}

